# Параметры запуска из командной строки

**Любой из параметров, кроме VAParams, можно передать в файле VAParams.json.**

| Параметр | Тип | Описание |
|--|--|--|
| VAParams | Строка |Путь к файлу json с основными настройками Vanessa-Automation. Устаревшее значение параметра: "VBParams".|
| StartFeaturePlayer | Булево | Параметр означает, что нужно запустить тесты на выполнение, согласно параметрам переданным в VAParams.  |
| QuietInstallVanessaExt или ТихаяУстановкаVanessaExt | Булево | Выполняет тихую установку компоненты VanessaExt, без показа модального диалога пользователю. Для работы опции необходима установка толстого клиента платформы и возможность запускать файловые базы. |
| InstallVanessaExtOnFailOfQuietInstall | Булево | Указывает, что если не получилось сделать тихую установку компоненты все равно выполнять её подключение. Это имеет смысл, если Vanessa Automation запускается на компьютере, на котором ранее уже проводилась установка данной версии внешней компоненты VanessaExt, и поэтому не будет вызван модальный диалог, который платформа показывает при первой установке компоненты. |
| QuietInstallVanessaExtAndClose | Булево | Выполняет тоже самое, что и предыдущая опция, но после установки компоненты сеанс 1С буде закрыт. Тесты при этом выполняться не будут. Используется для гарантированной установки внешней компоненты до запуска основного сеанса тестирования. |
| WorkspaceRoot | Строка | Определяет путь к каталогу проекта. По умолчанию каталогом проекта являет каталог, в котором находится основная обработка vanessa-automation.epf |
| ClearStepsCache | Булево |  Очищает кеш шагов при запуске Vanessa-Automation. Параметр может быть полезен, чтобы блокировать загрузку кеша шагов, который мог остаться у данного пользователя в данной базе. |
| DisableUserSettingsLoader | Булево | Отключает работу плагина "Загрузчик пользовательских настроек". Использование параметра уменьшает количество серверных вызовов, если не планируется использовать даный плагин. |
| DisableLoadTestClientsTable | Булево | Отключает загрузку списка клиентов тестирования. Параметр может быть полезен, чтобы блокировать загрузку списка клиентов тестирования, который мог остаться у данного пользователя в данной базе. |
| DisableLoadConfig | Булево |  Отключает загрузку настроек Vanessa-Automation. Параметр может быть полезен, чтобы блокировать загрузку настроек пользователя, которые могли остаться у данного пользователя в данной базе. |
| DisableFeatureLoadOnOpenForm | Булево |  Отключает загрузку фича файла при старте Vanessa-Automation. Аналогично установке {Объект.ЗагрузкаФичПриОткрытии = "Не загружать"} |
| DisableCheckPossibilityOfSynchronousCalls | Булево |  Отключает проверку возможности использования синхронных вызовов, несмотря на то, что в свойствах конфигурации они явно запрещены. Это нужно, т.к. в тонком клиенте часто возможно использовать синхронные вызовы несмотря на настройки конфигурации. |
| GetStepsCache | Булево | Служебный. Нужен при сборке Vanessa Automation Single. Т.к. Single уже внутри содержит всю библиотеку шагов. И сразу же содержит в себе рассчитанный кеш шагов. |
| DisableFileOptimization | Булево |  Служебный. Отключает механизм оптимизации работы с файлами для серверных баз, когда сервер запущен на том же ПК, что и клиент. Параметр используется для режима самотестирования Vanessa-Automation и использовать его в реальных запусках тестов не рекомендуется. |


При передаче указанных выше параметров в командной строке порядок параметров не важен. Параметры типа булево можно записывать не указывая значение. По умолчанию считается Истина. Значения параметров указываются либо через равно, либо просто указывается имя параметра, например:

    StartFeaturePlayer;VAParams=C:\Temp\features\VAParams.json;
